#include "Tpvc505.ch"

FUNCTION TraeIni()
 LOCAL oIniFile := TiniFile():Create("tpvc505.ini")

  oPath := oIniFile:ReadString( "DATOS","patho", "C:\")
  ExtFi := oIniFile:ReadString( "DATOS","extfi", "*.*")
  cPath := oIniFile:ReadString( "DATOS","pathc", "")
  dPath := oIniFile:ReadString( "DATOS","pathd", "")
  Nreme := oIniFile:ReadString( "DATOS","remesa", 1)

  oIniFile:Destroy()
  
RETURN NIL

FUNCTION DejaIni()

  LOCAL oIniFile  := TIniFile():Create("tpvc505.ini")

  oIniFile:WriteString( "DATOS","patho", oPath)
  oIniFile:WriteString( "DATOS","extfi", ExtFi)
  oIniFile:WriteString( "DATOS","pathC", cPath)
  oIniFile:WriteString( "DATOS","pathD", dPath)
  oIniFile:WriteString( "DATOS","remesa", Nreme)
  
  oIniFile:Destroy()

RETURN NIL

FUNCTION lImporte(FileName)
local FileIn := oPath+FileName
local nLee := SPACE(102)
local nManejador := FOPEN(FileIn)
IF FERROR() != 0
 MessageDlg( "El fichero "+ FileIn +"No se puede abrir el fichero, error DOS "+FERROR(), mtError, mbOk )
 RETURN 0
endif
suma := 0
FREAD(nManejador,@nLee,102)

IF LEFT(nLee,8) != "0TPVC505"
  MessageDlg( "El fichero "+ FileName +" no es un TPVC505, debe borrarlo y lanzar nuevamente la aplicacin", mtError, mbOk )
  FCLOSE(nManejador)
  RETURN 0
endif
Do while .T.
  FREAD(nManejador,@nLee,102)
  Do case
    Case LEFT(nLee,1) = "1" // Leer importe
         suma += VAL(SUBSTR(nLee,61,10))/100
    Case LEFT(nLee,1) = "9" // Linea de cola
      exit
   EndCase
Enddo
FCLOSE(nManejador)
Return suma

FUNCTION STRZERO(cl_num, cl_len)
LOCAL cl_str := STR(cl_num,cl_len,0)
RETURN REPLICATE("0",LEN(cl_str)-LEN(LTRIM(cl_str)) )+LTRIM(cl_str)

FUNCTION SLFECHA(svfecha)
LOCAL tempo
tempo=DTOC(svfecha)
RETURN(RIGHT(tempo,4)+SUBSTR(tempo,4,2)+LEFT(tempo,2))

FUNCTION STFECHA(svfecha)
LOCAL tempo
tempo=DTOC(svfecha)
RETURN(RIGHT(tempo,2)+SUBSTR(tempo,4,2)+LEFT(tempo,2))

FUNCTION ERDOS(pasa)
LOCAL quepasa
DO CASE
  CASE pasa = 2
    quepasa = "Archivo no encontrado"
  CASE pasa = 3
    quepasa = "Ruta no encontrada"
  CASE pasa = 4
    quepasa = "Demasiados archivos abiertos"
  CASE pasa = 5
    quepasa = "Acceso denegado El disco puede estar protegido"
  CASE pasa = 6
    quepasa = "Manipulador invlido"
  CASE pasa = 8
    quepasa = "Insuficiente memoria"
  CASE pasa = 15
    quepasa = "Unidad invlida especificada"
  CASE pasa = 19
    quepasa = "Intento de escritura a un disco protegido"
  CASE pasa = 20
    quepasa = "Unidad desconocida"
  CASE pasa = 21
    quepasa = "La unidad no est lista"
  CASE pasa = 23
    quepasa = "Error de datos CRC"
  CASE pasa = 29
    quepasa = "Error de escritura"
  CASE pasa = 30
    quepasa = "Error de lectura"
  CASE pasa = 32
    quepasa = "Error de comparticin"
  CASE pasa = 33
    quepasa = "Violacin del bloqueo"
  OTHERWISE
    quepasa = "Error Indeterminado "+str(pasa,3)
ENDCASE
RETURN quepasa

/*
 * Rutina de mensaje de errores.
 */
Function DefError( oError )

   Local cMessage, nChoice, i

   If oError:GenCode == EG_ZERODIV
      Return 0
   EndIf

   If oError:GenCode == EG_OPEN .And. oError:OsCode == 32 .And. oError:CanDefault
      NetErr( .T. )
      Return .F.
   EndIf

   If oError:GenCode == EG_APPENDLOCK .And. oError:CanDefault
      NetErr( .T. )
      Return .F.
   EndIf

   cMessage := ErrorMessage( oError )
//   aOptions := { "Quit" }
//
//   If e:CanRetry
//      aAdd( aOptions, "Retry" )
//   EndIf
//
//   If e:CanDefault
//      aAdd( aOptions, "Default" )
//   EndIf

   nChoice := 0

//   Do While nChoice == 0
//      If Empty( oError:OsCode )
//         nChoice := Alert( cMessage, aOptions )
//      Else
//         nChoice := Alert( cMessage + ";(DOS Error " + LTrim( Str( oError:OsCode ) ) + ")", aOptions )
//      EndIf
//
//      If nChoice == Nil
//         Exit
//      EndIf
//   EndDo
//
//   If !Empty( nChoice )
//      if aOptions[ nChoice ] == "Break"
//         Break( oError )
//      ElseIf aOptions[ nChoice ] == "Retry"
//         Return .T.
//      ElseIf aOptions[ nChoice ] == "Default"
//         Return .F.
//      EndIf
//   EndIf

   If !Empty( oError:OsCode )
      cMessage += " (DOS Error " + LTrim( Str( oError:OsCode ) ) + ") "
   EndIf

//   ? cMessage
   cMessage += Chr( 13 ) + Chr( 10 )

   i := 2

   Do While !Empty( ProcName( i ) )
//      ? "Called from", Trim( ProcName( i ) ) + "(" + LTrim( Str( ProcLine( i ) ) ) + ")  "
      cMessage += Chr( 13 ) + Chr( 10 ) + "- Llamado desde " + Trim( ProcName( i ) ) + "(" + LTrim( Str( ProcLine( i ) ) ) + ")  "
      i++
   EndDo

   OutErr( cMessage )
   ErrorLevel( 1 )
   __QUIT()

return .F.

/*
 * Genera el mensaje del error.
 */
Function ErrorMessage( oError )

   Local cMessage

   cMessage := If( oError:Severity > ES_WARNING, "Error ", "Warning " )

   If ValType( oError:SubSystem ) == "C"
      cMessage += oError:SubSystem()
   Else
      cMessage += "???"
   EndIf

   If ValType( oError:SubCode ) == "N"
      cMessage += "/" + LTrim( Str( oError:SubCode ) )
   Else
      cMessage += "/???" 
   EndIf

   If ValType( oError:Description ) == "C"
      cMessage += "  " + oError:Description
   EndIf

   If !Empty( oError:FileName )
      cMessage += ": " + oError:FileName
   ElseIf !Empty( oError:Operation )
      cMessage += ": " + oError:Operation
   EndIf

Return cMessage